//! # CRC's from scratch, nothing else
//!
//! This crate implements some CRC algorithms from scratch in a `no_std` environment.
//!
//! ## Acknowledgements
//!
//! Many thanks to the [crc-catalogue](https://reveng.sourceforge.io/crc-catalogue/) for providing
//! some test vectors.

#![cfg_attr(not(test), no_std)]

mod crc_32;

pub const CHECK_DATA: [u8; 9] = *b"123456789";

pub use crc_32::*;

pub trait Crc {
    type Input: ?Sized;
    type Checksum: Eq + Default;

    fn new() -> Self;
    fn process(&mut self, data: &Self::Input);
    fn shift_reg(&mut self) -> &mut Self::Checksum;
}
